package com.fp.persistence.pgeneral.gene;

import java.io.Serializable;
import java.lang.reflect.Field;
import java.math.BigDecimal;
import java.sql.Date;
import java.util.List;

import javax.persistence.Column;
import javax.persistence.EmbeddedId;
import javax.persistence.Entity;
import javax.persistence.EntityManager;
import javax.persistence.Query;
import javax.persistence.Table;
import javax.persistence.Transient;

import com.fp.dto.hb.HibernateBean;
import com.fp.teller.exception.TellerException;

/** Clase que implementa la entidad de Hibernate que hace referencia a la tabla TGENETELLERTRANSFERDETAIL */
@Entity(name = "TgeneTellerTransferDetail")
@Table(name = "TGENETELLERTRANSFERDETAIL")
public class TgeneTellerTransferDetail extends com.fp.dto.AbstractDataTransport
		implements
			Serializable,
			HibernateBean,
			Cloneable {
	/**
	 * HashCode asociado con la Instancia
	 */
	@Transient
	private int hashValue = 0;
	/**
	 * Version de la Clase
	 */
	private static final long serialVersionUID = 1L;
	/**
	 * Clave primaria de la Entidad TgeneTellerTransferDetail
	 */
	@EmbeddedId
	private TgeneTellerTransferDetailKey pk;
	@Column(name = "QUANTITY", nullable = true)
	/**
	 * Numero de billetes o monedas por denominacion
	 */
	private Integer quantity;

	@Column(name = "TOTAL", nullable = true)
	/**
	 * Total de la denominacion
	 */
	private BigDecimal total;

	/** Contructor por defecto */
	public TgeneTellerTransferDetail() {
	}
	/**
	 * Contructor de TgeneTellerTransferDetail
	 * 
	 * @param pPk Clave Primaria del entity
	 */
	public TgeneTellerTransferDetail(TgeneTellerTransferDetailKey pPk) {
		this();
		pk = pPk;
	}
	/**
	 * Metodo que entrega datos de la tabla dada la clave primaria.
	 * 
	 * @param pEntityManager referencia de la session a obtener datos del bean.
	 * @param pKey Caleve primaria del bean.
	 * @return TgeneTellerTransferDetail
	 */
	public static TgeneTellerTransferDetail find(EntityManager pEntityManager, TgeneTellerTransferDetailKey pKey)
			throws Exception {
		TgeneTellerTransferDetail obj = pEntityManager.find(TgeneTellerTransferDetail.class, pKey);
		return obj;
	}
	/**
	 * Entrega la Clave primaria de TgeneTellerTransferDetail
	 * 
	 * @return El objeto que referencia a la Clave primaria de TgeneTellerTransferDetail
	 */
	public TgeneTellerTransferDetailKey getPk() {
		return pk;
	}
	/**
	 * Fija un nuevo valor a la Clave primaria de TgeneTellerTransferDetail
	 * 
	 * @param pPk El objeto que referencia a la nueva Clave primaria de TgeneTellerTransferDetail
	 */
	public void setPk(TgeneTellerTransferDetailKey pPk) {
		pk = pPk;
	}
	/**
	 * Obtiene el valor de quantity
	 * 
	 * @return valor de quantity
	 */
	public Integer getQuantity() {
		return quantity;
	}
	/**
	 * Fija el valor de quantity
	 * 
	 * @param pQuantity nuevo Valor de quantity
	 */
	public void setQuantity(Integer pQuantity) {
		quantity = pQuantity;
	}

	/**
	 * Obtiene el valor de total
	 * 
	 * @return valor de total
	 */
	public BigDecimal getTotal() {
		return total;
	}
	/**
	 * Fija el valor de total
	 * 
	 * @param pTotal nuevo Valor de total
	 */
	public void setTotal(BigDecimal pTotal) {
		total = pTotal;
	}

	public boolean equals(Object rhs) {
		if (rhs == null)
			return false;
		if (!(rhs instanceof TgeneTellerTransferDetail))
			return false;
		TgeneTellerTransferDetail that = (TgeneTellerTransferDetail) rhs;
		if (this.getPk() == null || that.getPk() == null)
			return false;
		return (this.getPk().equals(that.getPk()));
	}
	/**
	 * Implementación del metodo hashCode de la la entidad TgeneTellerTransferDetail
	 * 
	 * @return el hashCode la instancia
	 */
	public int hashCode() {
		if (this.hashValue == 0) {
			int result = 17;
			if (this.getPk() == null) {
				result = super.hashCode();
			} else {
				result = this.getPk().hashCode();
			}
			this.hashValue = result;
		}
		return this.hashValue;
	}
	/** Implementación toString */
	public String toString() {
		Field[] fs = this.getClass().getDeclaredFields();
		String data = "";
		for (Field f : fs) {
			try {
				String name = f.getName();
				if (f.getType().getName().compareTo("java.util.Set") == 0)
					continue;
				if (name.compareTo("hashValue") == 0 || name.compareTo("serialVersionUID") == 0)
					continue;
				data += name + "=" + f.get(this) + ";";
			} catch (Exception e) {
				continue;
			}
		}
		if (data.compareTo("") == 0) {
			data = super.toString();
		}
		return data;
	}
	/** Implementación de la creación de un bean en blanco TgeneTellerTransferDetail */
	public Object createInstance() {
		TgeneTellerTransferDetail instance = new TgeneTellerTransferDetail();
		instance.setPk(new TgeneTellerTransferDetailKey());
		return instance;
	}
	/**
	 * Clona la entidad TgeneTellerTransferDetail
	 * 
	 * @see com.fp.dto.hb.HibernateBean#cloneMe()
	 */
	public Object cloneMe() throws CloneNotSupportedException {
		TgeneTellerTransferDetail p = (TgeneTellerTransferDetail) this.clone();
		p.setPk((TgeneTellerTransferDetailKey) this.pk.cloneMe());
		return p;
	}
	
	//Metodos manuales. 
    /**Sentencia que entrega la los datos de TgeneTellerTransferDetail*/
    private static final String HQL_TELLER_TRANSFER_DETAIL =
            " from TgeneTellerTransferDetail tgtd"
            + " where tgtd.pk.workingdate = :workingdate"
            + " and tgtd.pk.usercode = :usercode"
            + " and tgtd.pk.transfernumber = :transfernumber";

    /**
     * Metodo que entrega los datos de TgeneTellerTransferDetail, dada la fecha de trabajo, usuario y secuencia.
     * @param workingdate  Fecha de trabajo.
     * @param usercode  Codigo de usuario.
     * @param transfernumber  Numero de transferencia.
     * @return  List<TgeneTellerTransferDetail>
     * @throws Exception
     */
    @SuppressWarnings("unchecked")
	public static List<TgeneTellerTransferDetail> find(EntityManager pEntityManager,
    		Date workingdate, String usercode, Integer transfernumber) throws Exception{
    	List<TgeneTellerTransferDetail> ldata = null;
    	Query qry = pEntityManager.createQuery(HQL_TELLER_TRANSFER_DETAIL);
        qry.setParameter("workingdate", workingdate);
        qry.setParameter("usercode", usercode);
        qry.setParameter("transfernumber", transfernumber);
        ldata =  qry.getResultList();
        if(ldata == null){
            throw new TellerException("TELLER-0001", "TRANSFERENCIA NO DEFINIDA EN TGENETELLERTRANSFERHEADER TRANSFERNUMBER:{0} USERCODE:{1} WORKINGDATE:{2}", transfernumber, usercode, workingdate);
        }
        return ldata;
    }
    

	
}
